Index: trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrint.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrint.asm	(revision 392)
@@ -0,0 +1,219 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Functions for printing boot menu strings.
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html				
+;		
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; BootMenuPrint_RefreshItem
+;
+;	Parameters:
+;		CX:		Index of highlighted item
+;		DS:		RAMVARS segment
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		Does not matter
+;--------------------------------------------------------------------
+BootMenuPrint_RefreshItem:
+	call	BootMenu_GetDriveToDXforMenuitemInCX
+	jnc		BootMenuEvent_Completed					; if no menu item selected, out we go
+
+	push	bp
+	mov		bp, sp
+
+	call	FindDPT_ForDriveNumberInDL
+	jc		.notOurs
+
+	call	BootMenuInfo_ConvertDPTtoBX
+	mov		si, g_szDriveNumBOOTNFO					; special g_szDriveNum that prints from BDA
+	jmp		.go
+
+.notOurs:
+	mov		si,g_szDriveNum
+	mov		bx,g_szForeignHD						; assume a hard disk for the moment
+
+	test	dl, dl
+	js		.go
+	mov		bl,((g_szFloppyDrv)-$$ & 0xff)			; and revisit the earlier assumption...
+
+.go:
+	mov		ax, dx									; preserve DL for the floppy drive letter addition
+	call	DriveXlate_ToOrBack
+	push	dx										; translated drive number
+	push	bx										; sub string
+	add		al, 'A'									; floppy drive letter (we always push this although
+	push	ax										; the hard disks don't ever use it, but it does no harm)
+
+	jmp		SHORT BootMenuPrint_RefreshInformation.FormatRelay
+
+;--------------------------------------------------------------------
+; Prints Boot Menu title strings.
+;
+; BootMenuPrint_TitleStrings
+;	Parameters:
+;		Nothing
+;	Returns:
+;		CF:		Set since menu event handled
+;	Corrupts registers:
+;		AX, SI, DI
+;--------------------------------------------------------------------
+BootMenuPrint_TitleStrings:
+	mov		si, ROMVARS.szTitle
+	call	DetectPrint_NullTerminatedStringFromCSSIandSetCF
+	CALL_DISPLAY_LIBRARY PrintNewlineCharacters
+	mov		si, ROMVARS.szVersion
+	jmp		DetectPrint_NullTerminatedStringFromCSSIandSetCF
+
+
+;--------------------------------------------------------------------
+; BootMenuPrint_RefreshInformation
+;	Parameters:
+;		CX:		Index of highlighted item
+;		DS:		RAMVARS segment
+;	Returns:
+;		CF:		Set since menu event was handled successfully
+;	Corrupts registers:
+;		Does not matter
+;--------------------------------------------------------------------
+BootMenuPrint_RefreshInformation:
+	CALL_MENU_LIBRARY ClearInformationArea
+
+	call	BootMenu_GetDriveToDXforMenuitemInCX
+	jnc		BootMenuEvent_Completed						; if no menu selection, abort
+
+	push	bp
+	mov		bp, sp
+
+	mov		si, g_szCapacity							; Setup print string now, carries through to print call
+
+	call	FindDPT_ForDriveNumberInDL
+
+	inc		dl											; are we a hard disk?
+	dec		dl											; inc/dec will set SF, without modifying CF or DL
+	js		.HardDiskRefreshInformation
+
+	jnc		.ours										; Based on CF from FindDPT_ForDriveNumberInDL above
+	call	FloppyDrive_GetType							; Get Floppy Drive type to BX
+	jmp		.around
+.ours:
+	call	AH8h_GetDriveParameters
+.around:
+
+	mov		ax, g_szFddSizeOr	        				; .PrintXTFloppyType
+	test	bl, bl										; Two possibilities? (FLOPPY_TYPE_525_OR_35_DD)
+	jz		SHORT .PushAXAndOutput
+
+	mov		al, (g_szFddUnknown - $$) & 0xff	        ; .PrintUnknownFloppyType
+	cmp		bl, FLOPPY_TYPE_35_ED
+	ja		SHORT .PushAXAndOutput
+
+	; Fall to .PrintKnownFloppyType
+
+;--------------------------------------------------------------------
+; .PrintKnownFloppyType
+;	Parameters:
+;		BX:		Floppy drive type
+;	Returns:
+;		CF:		Set since menu event was handled successfully
+;	Corrupts registers:
+;		AX, BX, SI, DI
+;
+; Floppy Drive Types:
+;
+;   0  Handled above
+;   1  FLOPPY_TYPE_525_DD          5 1/4   360K
+;   2  FLOPPY_TYPE_525_HD          5 1/4   1.2M
+;   3  FLOPPY_TYPE_35_DD           3 1/2   720K
+;   4  FLOPPY_TYPE_35_HD           3 1/2   1.44M
+;   5  3.5" ED on some BIOSes      3 1/2   2.88M
+;   6  FLOPPY_TYPE_35_ED		   3 1/2   2.88M
+;   >6 Unknwon, handled above
+;
+;--------------------------------------------------------------------
+.PrintKnownFloppyType:
+	mov		al, (g_szFddSize - $$) & 0xff
+	push	ax
+
+	mov		al, (g_szFddThreeHalf - $$) & 0xff
+	cmp		bl, FLOPPY_TYPE_525_HD
+	ja		.ThreeHalf
+	mov		al, (g_szFddFiveQuarter - $$) & 0xff
+.ThreeHalf:
+	push	ax											; "5 1/4" or "3 1/2"
+
+	mov		al,FloppyTypes.rgbCapacityMultiplier
+	mov		bh, 0
+	mul		byte [cs:bx+FloppyTypes.rgbCapacity - 1]    ; -1 since 0 is handled above and not in the table
+
+.PushAXAndOutput:
+	push	ax
+
+.FormatRelay:
+	jmp		DetectPrint_FormatCSSIfromParamsInSSBP
+
+
+;--------------------------------------------------------------------
+; Prints Hard Disk Menuitem information strings.
+;
+; BootMenuPrint_HardDiskMenuitemInformation
+;	Parameters:
+;		DS:		RAMVARS segment
+;	Returns:
+;		CF:		Set since menu event was handled successfully
+;	Corrupts registers:
+;		BX, CX, DX, SI, DI, ES
+;--------------------------------------------------------------------
+.HardDiskRefreshInformation:
+	jc		.HardDiskMenuitemInfoForForeignDrive		; Based on CF from FindDPT_ForDriveNumberInDL (way) above
+
+.HardDiskMenuitemInfoForOurDrive:
+	ePUSH_T ax, g_szInformation							; Add substring for our hard disk information
+	call	BootMenuInfo_GetTotalSectorCount			; Get Total LBA Size
+	jmp		.ConvertSectorCountInBXDXAXtoSizeAndPushForFormat
+
+.HardDiskMenuitemInfoForForeignDrive:
+	call	DriveXlate_ToOrBack
+	call	AH15h_GetSectorCountFromForeignDriveToDXAX
+
+.ConvertSectorCountInBXDXAXtoSizeAndPushForFormat:
+	ePUSH_T	cx, g_szCapacityNum		; Push format substring
+	call	Size_ConvertSectorCountInBXDXAXtoKiB
+	mov		cx, BYTE_MULTIPLES.kiB
+	call	Size_GetSizeToAXAndCharToDLfromBXDXAXwithMagnitudeInCX
+	push	ax						; Size in magnitude
+	push	cx						; Tenths
+	push	dx						; Magnitude character
+
+	test	di,di
+	jz		SHORT BootMenuPrint_RefreshInformation.FormatRelay
+
+%include "BootMenuPrintCfg.asm"			; inline of code to fill out remainder of information string
+	jmp		DetectPrint_FormatCSSIfromParamsInSSBP
+
+
+FloppyTypes:
+.rgbCapacityMultiplier equ 20	        ; Multiplier to reduce word sized values to byte size
+.rgbCapacity:
+	db		360   / FloppyTypes.rgbCapacityMultiplier    ;  type 1
+	db		1200  / FloppyTypes.rgbCapacityMultiplier    ;  type 2
+	db		720   / FloppyTypes.rgbCapacityMultiplier    ;  type 3
+	db		1440  / FloppyTypes.rgbCapacityMultiplier    ;  type 4
+	db		2880  / FloppyTypes.rgbCapacityMultiplier    ;  type 5
+	db		2880  / FloppyTypes.rgbCapacityMultiplier    ;  type 6
Index: trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrintCfg.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrintCfg.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrintCfg.asm	(revision 392)
@@ -0,0 +1,142 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Functions for printing drive configuration
+;					information on Boot Menu.
+; 
+; Included by BootMenuPrint.asm, this routine is to be inserted into
+; BootMenuPrint_HardDiskRefreshInformation.
+;
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html				
+;
+				
+; Section containing code
+SECTION .text
+
+;;; fall-into from BootMenuPrint_HardDiskRefreshInformation.
+
+;--------------------------------------------------------------------
+; Prints Hard Disk configuration for drive handled by our BIOS.
+; Cursor is set to configuration header string position.
+;
+; BootMenuPrintCfg_ForOurDrive
+;	Parameters:
+;		DS:DI:		Pointer to DPT
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX, DX
+;--------------------------------------------------------------------
+.BootMenuPrintCfg_ForOurDrive:
+	eMOVZX	ax, [di+DPT.bIdevarsOffset]
+	xchg	bx, ax						; CS:BX now points to IDEVARS
+	; Fall to .PushAndFormatCfgString
+
+;--------------------------------------------------------------------
+; PushAddressingMode
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (jumps to next push below)
+;	Corrupts registers:
+;		AX, CX
+;--------------------------------------------------------------------
+.PushAddressingMode:
+	AccessDPT_GetUnshiftedAddressModeToALZF
+	;;
+	;; This multiply both shifts the addressing mode bits down to low order bits, and
+	;; at the same time multiplies by the size of the string displacement.  The result is in AH,
+	;; with AL clear, and so we exchange AL and AH after the multiply for the final result.
+	;;
+	mov		cl,(1<<(8-ADDRESSING_MODE_FIELD_POSITION)) * g_szAddressingModes_Displacement
+	mul		cl
+	xchg	al,ah
+	add		ax,g_szAddressingModes
+	push	ax
+
+;--------------------------------------------------------------------
+; PushBlockMode
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (falls to next push below)
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+.PushBlockMode:
+	mov		ax, 1
+	test	BYTE [di+DPT.bFlagsHigh], FLGH_DPT_BLOCK_MODE_SUPPORTED
+	jz		SHORT .PushBlockSizeFromAX
+	mov		al, [di+DPT_ATA.bBlockSize]
+.PushBlockSizeFromAX:
+	push	ax
+
+;--------------------------------------------------------------------
+; PushBusType
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (jumps to next push below)
+;	Corrupts registers:
+;		AX, DX
+;--------------------------------------------------------------------
+.PushBusType:
+	mov		al,g_szBusTypeValues_Displacement
+	mul		BYTE [cs:bx+IDEVARS.bDevice]
+
+	shr		ax,1			; divide by 2 since IDEVARS.bDevice is multiplied by 2
+
+	add		ax,g_szBusTypeValues
+	push	ax
+
+;--------------------------------------------------------------------
+; PushIRQ
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (falls to next push below)
+;	Corrupts registers:
+;		AX, DX
+;--------------------------------------------------------------------
+.PushIRQ:
+	mov		al, [cs:bx+IDEVARS.bIRQ]
+	cbw
+	push	ax
+
+;--------------------------------------------------------------------
+; PushResetStatus
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (falls to next push below)
+;	Corrupts registers:
+;		AX, BX, DX, ES
+;--------------------------------------------------------------------
+.PushResetStatus:
+	xor		ax, ax
+%ifdef MODULE_SERIAL
+	test	BYTE [di+DPT.bFlagsHigh], FLGH_DPT_SERIAL_DEVICE
+	jnz		SHORT .AlwaysSuccess
+	mov		al, [di+DPT_ATA.bInitError]
+.AlwaysSuccess:
+%endif
+	push	ax
+
+;;; fall-out to BootMenuPrint_HardDiskRefreshInformation.
Index: trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm	(revision 392)
@@ -0,0 +1,473 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Hotkey Bar related functions.
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html		
+;		
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; HotkeyBar_UpdateDuringDriveDetection
+;	Parameters:
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+HotkeyBar_UpdateDuringDriveDetection:
+	call	ScanHotkeysFromKeyBufferAndStoreToBootvars
+	; Fall to HotkeyBar_DrawToTopOfScreen
+
+
+;--------------------------------------------------------------------
+; HotkeyBar_DrawToTopOfScreen
+;	Parameters:
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+HotkeyBar_DrawToTopOfScreen:
+	; Store current screen coordinates to be restored
+	; when Hotkey Bar is rendered
+	call	DetectPrint_GetSoftwareCoordinatesToAX
+	push	ax
+
+	call	MoveCursorToScreenTopLeftCorner
+	; Fall to .PrintFloppyDriveHotkeys
+
+;--------------------------------------------------------------------
+; .PrintFloppyDriveHotkeys
+;	Parameters:
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+.PrintFloppyDriveHotkeys:
+	call	FloppyDrive_GetCountToAX
+	test	ax, ax		; Any Floppy Drives?
+	jz		SHORT .SkipFloppyDriveHotkeys
+
+	mov		di, DEFAULT_FLOPPY_DRIVE_LETTER | (ANGLE_QUOTE_RIGHT<<8)
+	mov		cl, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bFddLetter]
+	mov		si, g_szFDD
+	call	FormatDriveHotkeyString
+
+.SkipFloppyDriveHotkeys:
+	; Fall to .PrintHardDriveHotkeys
+
+;--------------------------------------------------------------------
+; .PrintHardDriveHotkeys
+;	Parameters:
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+	call	HotkeyBar_GetLetterForFirstHardDriveToAX
+	mov		ah, ANGLE_QUOTE_RIGHT
+	xchg	di, ax
+	mov		cl, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bHddLetter]
+	mov		si, g_szHDD
+	call	FormatDriveHotkeyString
+	; Fall to .PrintBootMenuHotkey
+
+;--------------------------------------------------------------------
+; .PrintBootMenuHotkey
+;	Parameters:
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+.PrintBootMenuHotkey:
+%ifdef MODULE_BOOT_MENU
+	mov		ah, BOOT_MENU_HOTKEY_SCANCODE
+	mov		di, 'F' | ('2'<<8)		; F2
+	mov		si, g_szBootMenu
+	call	FormatFunctionHotkeyString
+%endif
+	; Fall to .PrintRomBootHotkey
+
+;--------------------------------------------------------------------
+; .PrintRomBootHotkey
+;	Parameters:
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+.PrintRomBootHotkey:
+	mov		ah, ROM_BOOT_HOTKEY_SCANCODE
+	mov		di, 'F' | ('8'<<8)		; F8
+	mov		si, g_szRomBoot
+	call	FormatFunctionHotkeyString
+	; Fall to .EndHotkeyBarRendering
+
+;--------------------------------------------------------------------
+; .EndHotkeyBarRendering
+;	Parameters:
+;		Stack:	Screen coordinates before drawing Hotkey Bar
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DI
+;--------------------------------------------------------------------
+.EndHotkeyBarRendering:
+	call	HotkeyBar_ClearRestOfTopRow
+	pop		ax
+	jmp		SHORT HotkeyBar_RestoreCursorCoordinatesFromAX
+
+
+;--------------------------------------------------------------------
+; HotkeyBar_ClearRestOfTopRow
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DI
+;--------------------------------------------------------------------
+HotkeyBar_ClearRestOfTopRow:
+	CALL_DISPLAY_LIBRARY	GetColumnsToALandRowsToAH
+	eMOVZX	cx, al
+	CALL_DISPLAY_LIBRARY	GetSoftwareCoordinatesToAX
+	sub		cl, al
+	mov		al, ' '
+	CALL_DISPLAY_LIBRARY	PrintRepeatedCharacterFromALwithCountInCX
+	ret
+
+
+;--------------------------------------------------------------------
+; FormatDriveHotkeyString
+;	Parameters:
+;		CL:			Drive letter hotkey from BOOTVARS
+;		DI low:		First character for drive key string
+;		DI high:	Second character for drive key string (ANGLE_QUOTE_RIGHT)
+;		SI:			Offset to hotkey description string
+;		ES:			BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+FormatDriveHotkeyString:
+	ePUSH_T	ax, PushHotkeyParamsAndFormat
+	jmp		SHORT GetNonSelectedHotkeyDescriptionAttributeToDX
+
+
+;--------------------------------------------------------------------
+; FormatFunctionHotkeyString
+;	Parameters:
+;		AH:			Hotkey scancode to compare with BOOTVARS.hotkeyVars+HOTKEYVARS.bScancode
+;		SI:			Offset to hotkey description string
+;		DI low:		First character for drive key string
+;		DI high:	Second character for drive key string
+;		ES:			BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, SI, DI
+;--------------------------------------------------------------------
+FormatFunctionHotkeyString:
+	ePUSH_T	ax, PushHotkeyParamsAndFormat
+	mov		cx, g_szBoot		; Description parameter string
+	cmp		[es:BOOTVARS.hotkeyVars+HOTKEYVARS.bScancode], ah
+	jne		SHORT GetNonSelectedHotkeyDescriptionAttributeToDX
+	; Fall to GetSelectedHotkeyDescriptionAttributeToDX
+
+
+;--------------------------------------------------------------------
+; GetSelectedHotkeyDescriptionAttributeToDX
+; GetNonSelectedHotkeyDescriptionAttributeToDX
+;	Parameters:
+;		CF:		Set if selected hotkey
+;				Cleared if unselected hotkey
+;	Returns:
+;		DX:		Description Attribute
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+%ifdef MODULE_BOOT_MENU
+GetSelectedHotkeyDescriptionAttributeToDX:
+	push	si
+	mov		si, ATTRIBUTE_CHARS.cHurryTimeout		; Selected hotkey
+	jmp		SHORT GetDescriptionAttributeToDX
+
+GetNonSelectedHotkeyDescriptionAttributeToDX:
+	push	si
+	mov		si, ATTRIBUTE_CHARS.cHighlightedItem	; Unselected hotkey
+
+	; Display Library should not be called like this
+GetDescriptionAttributeToDX:
+	call	MenuAttribute_GetToAXfromTypeInSI
+	pop		si
+	xchg	dx, ax					; DX = Description attribute
+	ret
+
+%else	; No boot menu so use simpler attributes
+
+GetSelectedHotkeyDescriptionAttributeToDX:
+	mov		dl, MONO_REVERSE_BLINK
+	ret
+
+GetNonSelectedHotkeyDescriptionAttributeToDX:
+	mov		dl, MONO_REVERSE
+	ret
+%endif
+
+
+;--------------------------------------------------------------------
+; PushHotkeyParamsAndFormat
+;	Parameters:
+;		DI low:		First character
+;		DI high:	Second character
+;		DX:			Description Attribute
+;		CX:			Description string parameter
+;		CS:SI:		Description string
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, SI, DI
+;--------------------------------------------------------------------
+PushHotkeyParamsAndFormat:
+	push	bp
+	mov		bp, sp
+
+	mov		ax, MONO_BRIGHT
+	push	ax				; Key attribute
+	xchg	ax, di
+	push	ax				; First character
+	xchg	al, ah
+	push	ax				; Second character
+
+	push	dx				; Description attribute
+	push	si				; Description string
+	push	cx				; Description string parameter
+
+	push	di				; Key attribute for last space
+	mov		si, g_szHotkey
+	jmp		DetectPrint_FormatCSSIfromParamsInSSBP
+
+
+;--------------------------------------------------------------------
+; MoveCursorToScreenTopLeftCorner
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, DI
+;--------------------------------------------------------------------
+MoveCursorToScreenTopLeftCorner:
+	xor		ax, ax			; Top left corner (0, 0)
+	; Fall to HotkeyBar_RestoreCursorCoordinatesFromAX
+
+
+;--------------------------------------------------------------------
+; HotkeyBar_RestoreCursorCoordinatesFromAX
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, DI
+;--------------------------------------------------------------------
+HotkeyBar_RestoreCursorCoordinatesFromAX:
+	CALL_DISPLAY_LIBRARY	SetCursorCoordinatesFromAX
+	ret
+
+
+;--------------------------------------------------------------------
+; ScanHotkeysFromKeyBufferAndStoreToBootvars
+;	Parameters:
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX
+;--------------------------------------------------------------------
+ScanHotkeysFromKeyBufferAndStoreToBootvars:
+	call	Keyboard_GetKeystrokeToAX
+	jz		SHORT NoHotkeyToProcess
+
+	ePUSH_T	cx, ScanHotkeysFromKeyBufferAndStoreToBootvars
+	; Fall to HotkeyBar_StoreHotkeyToBootvarsIfValidKeystrokeInAX
+
+
+;--------------------------------------------------------------------
+; HotkeyBar_StoreHotkeyToBootvarsIfValidKeystrokeInAX
+;	Parameters:
+;		AL:		Hotkey ASCII code
+;		AH:		Hotkey Scancode
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		CF:		Set if valid keystroke
+;				Clear if invalid keystroke
+;	Corrupts registers:
+;		AX, CX, DI
+;--------------------------------------------------------------------
+HotkeyBar_StoreHotkeyToBootvarsIfValidKeystrokeInAX:
+	; Boot menu
+%ifdef MODULE_BOOT_MENU
+	cmp		ah, BOOT_MENU_HOTKEY_SCANCODE	; Display Boot Menu?
+	je		SHORT .StoreFunctionHotkeyFromAH
+%endif
+
+	; ROM Boot
+	cmp		ah, ROM_BOOT_HOTKEY_SCANCODE	; ROM Boot?
+	je		SHORT .StoreFunctionHotkeyFromAH
+
+	; Drive letter hotkeys remaining, allow 'a' to 'z'
+	call	Char_IsLowerCaseLetterInAL
+	jnc		SHORT .KeystrokeIsNotValidHotkey
+	call	Char_ChangeCaseInAL		; We want to print upper case letters
+
+	; Clear HD First flag to assume Floppy Drive hotkey
+	mov		di, BOOTVARS.hotkeyVars+HOTKEYVARS.bFlags
+	and		BYTE [es:di], ~FLG_HOTKEY_HD_FIRST
+
+	; Determine if Floppy or Hard Drive hotkey
+	eMOVZX	cx, al					; Clear CH to clear scancode
+	call	HotkeyBar_GetLetterForFirstHardDriveToAX
+	cmp		cl, al
+	jb		SHORT .StoreDriveLetter	; Store Floppy Drive letter
+
+	; Store Hard Drive letter
+	or		BYTE [es:di], FLG_HOTKEY_HD_FIRST
+
+.StoreDriveLetter:
+	adc		di, BYTE 0			; Add 1 if Floppy Drive
+	xchg	ax, cx
+	mov		[es:di+1], al		; AH = zero to clear function hotkey
+
+.StoreFunctionHotkeyFromAH:
+	mov		[es:BOOTVARS.hotkeyVars+HOTKEYVARS.bScancode], ah
+	stc		; Valid hotkey
+
+.KeystrokeIsNotValidHotkey:
+NoHotkeyToProcess:
+	ret
+
+
+;--------------------------------------------------------------------
+; HotkeyBar_GetSecondaryBootDriveNumberToDL
+; HotkeyBar_GetPrimaryBootDriveNumberToDL
+;	Parameters:
+;		DS:		RAMVARS segment
+;		ES:		BDA segment (zero)
+;	Returns:
+;		DL:		Drive selected as boot device
+;	Corrupts registers:
+;		AX, DH
+;--------------------------------------------------------------------
+HotkeyBar_GetSecondaryBootDriveNumberToDL:
+	mov		dx, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wHddAndFddLetters]
+	xchg	dl, dh
+	jmp		SHORT GetBootDriveNumberFromLettersInDX
+
+HotkeyBar_GetPrimaryBootDriveNumberToDL:
+	mov		dx, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wHddAndFddLetters]
+GetBootDriveNumberFromLettersInDX:
+	test	BYTE [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bFlags], FLG_HOTKEY_HD_FIRST
+	eCMOVZ	dl, dh
+	; Fall to ConvertDriveLetterInDLtoDriveNumber
+
+
+;--------------------------------------------------------------------
+; ConvertDriveLetterInDLtoDriveNumber
+;	Parameters:
+;		DS:		RAMVARS segment
+;		DL:		Drive letter ('A'...)
+;	Returns:
+;		DL:		Drive number (0xh for Floppy Drives, 8xh for Hard Drives)
+;	Corrupts registers:
+;		AX, DH
+;--------------------------------------------------------------------
+ConvertDriveLetterInDLtoDriveNumber:
+	call	HotkeyBar_GetLetterForFirstHardDriveToAX
+	cmp		dl, al
+	jb		SHORT .ConvertLetterInDLtoFloppyDriveNumber
+
+	; Convert letter in DL to Hard Drive number
+	sub		dl, al
+	or		dl, 80h
+	ret
+
+.ConvertLetterInDLtoFloppyDriveNumber:
+	sub		dl, DEFAULT_FLOPPY_DRIVE_LETTER
+	ret
+
+
+;--------------------------------------------------------------------
+; HotkeyBar_ConvertDriveNumberFromDLtoDriveLetter
+;	Parameters:
+;		DL:		Drive number (0xh for Floppy Drives, 8xh for Hard Drives)
+;		DS:		RAMVARS Segment
+;	Returns:
+;		DL:		Drive letter ('A'...)
+;		CF:		Set if Hard Drive
+;				Clear if Floppy Drive
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+HotkeyBar_ConvertDriveNumberFromDLtoDriveLetter:
+	test	dl, dl
+	jns		SHORT .GetDefaultFloppyDrive
+
+	; Store default hard drive to boot from
+	call	HotkeyBar_GetLetterForFirstHardDriveToAX
+	sub		dl, 80h
+	add		dl, al
+	stc
+	ret
+
+.GetDefaultFloppyDrive:
+	add		dl, DEFAULT_FLOPPY_DRIVE_LETTER		; Clears CF
+	ret
+
+
+;--------------------------------------------------------------------
+; Returns letter for first hard disk. Usually it will be 'C' but it
+; can be higher if more than two floppy drives are found.
+;
+; HotkeyBar_GetLetterForFirstHardDriveToAX
+;	Parameters:
+;		DS:		RAMVARS segment
+;	Returns:
+;		AX:		Upper case letter for first hard disk
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+HotkeyBar_GetLetterForFirstHardDriveToAX:
+	call	FloppyDrive_GetCountToAX
+	add		al, DEFAULT_FLOPPY_DRIVE_LETTER
+	MAX_U	al, DEFAULT_HARD_DRIVE_LETTER
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 392)
@@ -73,8 +73,9 @@
 
 ; Boot loader strings
-g_szTryToBoot:			db	"Booting from %s %x",ANGLE_QUOTE_RIGHT,"%x",LF,CR,NULL
+g_szTryToBoot:			db	"Booting %c",ANGLE_QUOTE_RIGHT,"%c",LF,CR,NULL
 g_szBootSectorNotFound:	db	"Boot sector "
 g_szNotFound:			db	"not found",LF,CR,NULL
 g_szReadError:			db	"Error %x!",LF,CR,NULL
+
 
 g_szAddressingModes:
@@ -143,8 +144,10 @@
 
 ; Boot menu bottom of screen strings
-g_szFDD:		db	"FDD     ",NULL
-g_szHDD:		db	"HDD     ",NULL
-g_szRomBoot:	db	"ROM Boot",NULL
-g_szHotkey:		db	"%A%c%c%A%s%A ",NULL
+g_szFDD:		db	"FDD [%c]",NULL			; "FDD [A]"
+g_szHDD:		db	"HDD [%c]",NULL			; "HDD [C]"
+g_szBootMenu:	db	"%sMnu",NULL			; "BootMnu"
+g_szRomBoot:	db	"Rom%s",NULL			; "RomBoot"
+g_szBoot:		db	"Boot",NULL
+g_szHotkey:		db	"%A%c%c%A%s%A ",NULL	; "C»HDD [A] ", "F2BootMnu " or "F8RomBoot "
 
 ; Boot Menu information strings
@@ -227,4 +230,2 @@
 ;
 ;------------------------------------------------------------------------------------------
-
-
